#!/usr/bin/env python

#
# v1, January 24, 2014
# by Fabien Delmotte
#
# Reference: AX_aXAPI_Ref_v2.8.pdf
# Usage:
# Librairy
#

import httplib, json, urllib, urllib2, optparse
import socket, ssl, time, re
from xml.etree import ElementTree

# patch httplib.HTTPSConnection.connect
def connect_patched(self):
    sock = socket.create_connection((self.host, self.port),self.timeout, self.source_address)
    if self._tunnel_host:
        self.sock = sock
        self._tunnel()
    self.sock = ssl.wrap_socket(sock, self.key_file, self.cert_file, ssl_version=ssl.PROTOCOL_TLSv1)
    

def get_session_id(device):
    httplib.HTTPSConnection.connect = connect_patched
    
    #Gets the session ID to
    c = httplib.HTTPSConnection(device)
    c.request("GET", "/services/rest/V2.8/?method=authenticate&username=admin&password=a10&format=json")
    response = c.getresponse()
    data = json.loads(response.read())
    session_id = data['session_id']
    return session_id
    
def send_request(device,session_id,method,post_body):
    url = "https://" + device + "/services/rest/V2.8/?&session_id=" + session_id + "&format=json&method=" + method
    req = urllib2.Request(url, post_body)
    rsp = urllib2.urlopen(req)
    return rsp.read()